package org.rcisoft.common.util.outClient;


//import com.zgiot.zx.schedule.service.INotificationService;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.core.result.ResultCode;
import org.rcisoft.core.result.Ret;
import org.rcisoft.common.util.feignClient.NotificationFeignClient;
import org.rcisoft.common.util.feignDto.MTNotificationSendReqDTO;
import org.rcisoft.common.util.feignDto.MTUserGetsReqDTO;
import org.rcisoft.common.util.feignDto.MTUserInfoRspDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 消息通知接口调用
 * @author David
 */
@Component
@Slf4j
public class MTNotificationApiRequestClient {

//    @Autowired
    private NotificationFeignClient notificationFeignClient;
    @Autowired
    private MTCotactApiRequestClient mtCotactApiRequestClient;
//    @Autowired
//    private INotificationService notificationService;

    /**
     * 发送通知
     * @param mtNotificationSendReqDTO
     * @return
     */
    public boolean send(MTNotificationSendReqDTO mtNotificationSendReqDTO, String type) {
        List<String> userIds = mtNotificationSendReqDTO.getReceiverIds();
        List<String> accountIds = new ArrayList<>();
        MTUserGetsReqDTO mtUserGetsReqDTO = new MTUserGetsReqDTO();
        mtUserGetsReqDTO.setCorpId(mtNotificationSendReqDTO.getCorpId());
        mtUserGetsReqDTO.setIds(userIds);
        List<MTUserInfoRspDTO> allUserList = mtCotactApiRequestClient.userGets(mtUserGetsReqDTO);
        if(allUserList != null && allUserList.size() > 0){
            for(MTUserInfoRspDTO mtUserInfoRspDTO : allUserList){
                accountIds.add(mtUserInfoRspDTO.getAccountId());
            }
        }
        log.info("消息发送人accountId:" + accountIds);
        mtNotificationSendReqDTO.setReceiverIds(accountIds);
        mtNotificationSendReqDTO.setChannels("ALL");
        mtNotificationSendReqDTO.setCategoryCodes(Arrays.asList(new String[]{type}));
        Ret ret = notificationFeignClient.sendMessage(mtNotificationSendReqDTO,"app",(long)1);
        if(ret != null && ResultCode.SUCCESS.getCode().toString().equals(ret.getCode())){
            return true;
        }
        return false;
    }

}
